#pragma once

class CWindowInfo
{
protected:
	bool m_docable;
	CWnd *m_docker;
	CWnd *m_main;
	bool m_isdocker;
	inline bool IsStick(const int ms,const int ss)
	{
		return ((ms-ss)==0);
	}
public:
	inline bool IsClose(const int ms,const int ss, const int sl)
	{
		return abs(ms-ss)<sl;
	}
	CWindowInfo(const CWnd *pWnd=NULL);
	CWindowInfo(const CWindowInfo& copy);
	CWindowInfo &operator =(const CWindowInfo& copy);
	operator CWnd *(void) const;
	operator HWND(void) const;
	bool Dockable(void) const;
	void Dockable(const bool bDockable);
	CWnd *Docker(void) const;
	void Docker(const CWnd *);
	bool Intersect(const CRect &r1,const CRect &r2,const int slack);
	bool IsDocker(void) const;
	void SetDocker(const bool bDocker);
	bool CheckStick(const CWindowInfo& cwi,const int slack);
	CRect Move(const CPoint &pp);
	bool NeedDock(LPRECT mrect,CPoint &delta,const int slack);
	~CWindowInfo(void);
};

