#pragma once

#include "StickyDragManager.h"
// CStickyDialog dialog

class CStickyDialog : public CDialog
{
	DECLARE_DYNAMIC(CStickyDialog)
public:
	CStickyDialog():
			CDialog() {}
	CStickyDialog(LPCTSTR lpszTemplateName,CWnd* pParent = NULL):
			CDialog(lpszTemplateName, pParent) 	{}
	CStickyDialog(UINT nIDTemplate,CWnd* pParent = NULL):
			CDialog(nIDTemplate, pParent) {}
	virtual ~CStickyDialog();
	bool IsDocker(void) const;
	bool IsDockable(void) const;
	void Docker(const bool bDocker);
	void Dockable(const bool bDockable);
protected:
	static CStickyDragManager m_dragManager;
	CPoint m_relativeOffset;
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnClose();
	afx_msg void OnMoving(UINT fwSide, LPRECT pRect);
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	virtual BOOL OnInitDialog();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
};
